summaryrefslogtreecommitdiff
path: root/third_party/bigint/run-testsuite
diff options
context:
space:
mode:
authorBo Xu <bo_xu@foxitsoftware.com>2014-12-02 13:06:22 -0800
committerBo Xu <bo_xu@foxitsoftware.com>2014-12-02 13:06:22 -0800
commit7504b3d87d6143661746d85c3c3e4052939b4e52 (patch)
tree3baa8695a001c3226719409b666db31c3153f039 /third_party/bigint/run-testsuite
parent4643533ca3dabe945fd174caf892a3ccb6cf2fd6 (diff)
downloadpdfium-7504b3d87d6143661746d85c3c3e4052939b4e52.tar.xz
Initial check in of big integer library, v2010.04.30
R=tsepez@chromium.org Review URL: https://codereview.chromium.org/773443004
Diffstat (limited to 'third_party/bigint/run-testsuite')
-rwxr-xr-xthird_party/bigint/run-testsuite37
1 files changed, 37 insertions, 0 deletions
diff --git a/third_party/bigint/run-testsuite b/third_party/bigint/run-testsuite
new file mode 100755
index 0000000000..ff73729164
--- /dev/null
+++ b/third_party/bigint/run-testsuite
@@ -0,0 +1,37 @@
+#!/bin/bash
+
+bad=
+
+# If you encounter the following problem with Valgrind like I did:
+# https://bugzilla.redhat.com/show_bug.cgi?id=455644
+# you can pass the environment variable NO_VALGRIND=1 to run the testsuite
+# without it.
+if [ "$NO_VALGRIND" ]; then
+ cmd=(./testsuite)
+else
+ cmd=(valgrind --error-exitcode=1 --leak-check=full ./testsuite)
+fi
+
+set -o pipefail
+# Stdout goes directly to testsuite.out; stderr goes down the pipe.
+if ! "${cmd[@]}" 2>&1 >testsuite.out | tee testsuite.err; then
+ echo >&2 'Memory errors!'
+ bad=1
+fi
+
+if grep 'LEAK SUMMARY' testsuite.err >/dev/null; then
+ echo >&2 'Memory leaks!'
+ bad=1
+fi
+
+if ! diff -u testsuite.expected testsuite.out; then
+ echo >&2 'Output is incorrect!'
+ bad=1
+fi
+
+if [ $bad ]; then
+ echo >&2 'Test suite failed!'
+ exit 1
+else
+ echo 'Test suite passed.'
+fi